/*
 * Main.fx
 *
 * Created on 06.07.2009, 22:02:42
 * Created by Clemens Weidenhiller / Jeme
 * Please do not use this code without the permission of the author.
 * Breakout v 1.2 Beta
 */

package breakout;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.text.Text;
import javafx.scene.text.Font;
import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import breakout.MyVector;
import javafx.scene.input.MouseEvent;
import javafx.scene.Cursor;
import javafx.scene.image.ImageView;
import javafx.scene.image.Image;

import javafx.geometry.Point2D;


import javafx.scene.media.MediaPlayer;

import javafx.scene.media.Media;
import javafx.util.Math;


import javafx.animation.Interpolator;
import breakout.MyDestructibles;

import javafx.scene.effect.Lighting;
import javafx.scene.effect.light.DistantLight;

import java.io.File;

import javafx.scene.effect.InvertMask;
import javafx.scene.effect.GaussianBlur;






/**
 * @author jeme
 */

//create a path and animation for every block
var blockTimeLines:Timeline[];
var forceTxtUpdates:Timeline;

var inIterPower:Boolean;
var powerUp:MyPowerup;
var throughWalls:Boolean;
var shortened:Boolean;
var powerDown:MyPowerDown;
var myPowerUps:MyPowerup[];

var myPowerDowns:MyPowerDown[];

var backGrImg:ImageView = ImageView{x:-5 y:50 preserveRatio:false image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\background2.png"}};

var itera:Integer = 0;

def player:Player = Player{};
var won:Boolean = false;

var visibleTxt1:Boolean = false;
var visibleTxt2:Boolean = false;


var loadVisible:Boolean = false;
var loadTxt1:String = "loading.";
var loadTxt2:String = "loading..";
var loadTxt3:String = "loading...";
var loadTxt4:String = "loading....";
var loadTxt5:String = "loading.....";
var loadTxt6:String = "loading......";

var loadingTxtField:Text = Text{font:Font{size:20} fill:Color.BLACK visible:bind loadVisible x:400 y:500};
var loadTimeLine:Timeline = Timeline{repeatCount:Timeline.INDEFINITE autoReverse:false keyFrames: [KeyFrame{time:0.0s action:function():Void{loadingTxtField.content = loadTxt1;}}
                                                 KeyFrame{time:0.1s action:function():Void{loadingTxtField.content = loadTxt2;}}
                                                 KeyFrame{time:0.2s action:function():Void{loadingTxtField.content = loadTxt3;}}
                                                 KeyFrame{time:0.3s action:function():Void{loadingTxtField.content = loadTxt4;}}
                                                 KeyFrame{time:0.4s action:function():Void{loadingTxtField.content = loadTxt5;}}
                                                 KeyFrame{time:0.5s action:function():Void{loadingTxtField.content = loadTxt6;}}]};

var txtField1:Text = Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:60
                                oblique:true
                            }
                            visible:bind visibleTxt1
                            fill:Color.GREEN
                            x: 200
                            y: 100
                        };

var txtField2:Text = Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:22
                            }
                            visible:bind visibleTxt2
                            fill:Color.YELLOW
                            x: 160
                            y: 400
                        };
var myTxtFields:Text[];

var visibleTxt3:Boolean = false;

var txtField4:Text = Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:22
                            }
                            visible:bind visibleTxt3
                            fill:Color.RED
                            x: 160
                            y: 300
                        }

//The GameOver Text-field
var visibleTxt4:Boolean = false;
var txtField5:Text = Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:100
                            }
                            visible:bind visibleTxt4
                            fill:Color.RED
                            x:100
                            y:300
                            content:"  GAME OVER"
                        };
var visibleTxt5:Boolean = false;
var levelString:String = "Episode 1 - Pacman's not dead...";
var levelTXT:Text = Text
                    {
                        font:Font
                            {
                                embolden:true
                                size:50
                            }
                            effect: Lighting
                                {
                                    light: DistantLight { azimuth: -100 elevation: 30 }
                                    surfaceScale:4.0
                                }
                            visible:bind visibleTxt5
                            fill:Color.BLUE
                            x:70
                            y:250
                            content:bind levelString
                    }


//The current level
var level:Integer = 0;

var myDestructibleObjects:MyDestructibles[];

var movementSpeed:MyVector;
var mouseMoved:Boolean = false;
var moveVec:MyVector;

var lifeString:String  = "x {player.myLifes}";
var scoreString:String = "Score: {player.myScore}";

def bubbleSound:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{} media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/ballhit.wav"}};
var chainSounds:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{}};
def robotSound:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{robotSoundLoop.play();} media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/robot.wav"}};
def arcadeSound:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{arcadeSoundLoop.play();} media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/arcadeSound.wav"}};
def arcadeSoundLoop:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{arcadeSoundLoop.currentTime = 0.1s} repeatCount:MediaPlayer.REPEAT_FOREVER volume:0.5  media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/arcadeSoundLoop.wav"}};
def robotSoundLoop:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{robotSoundLoop.currentTime = 0.1s} repeatCount:MediaPlayer.REPEAT_FOREVER volume:0.5  media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/robotLoop.wav"}};
def easterSoundLoop:MediaPlayer = MediaPlayer{onEndOfMedia:function():Void{easterSoundLoop.currentTime = 0.1s} repeatCount:MediaPlayer.REPEAT_FOREVER volume:0.5  media:Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/easter.wav"}};

def gameOverSound:Media = Media{source:"file:/{new File(".").getCanonicalPath().replace("\\","/")}/Sounds/gameOVER.wav"};

var gameInfos1:Text = Text
                        {
                            font : Font
                                    {
                                        size : 16
                                    }
                                    x: 120
                                    y: 25
                                    content: bind lifeString
                        }
                        ;

var gameInfos2:Text = Text
                        {
                            font : Font
                                    {
                                        size : 26
                                        embolden:true
                                    }
                                    fill:Color.GOLD
                                    x: 400
                                    y: 25
                                    content: bind scoreString
                        }
                        ;


var myStage:Stage = Stage
    {
        title: "ChSim Breakout"
        width: 900
        height: 700
        resizable:false
        scene: Scene
        {
            content:
            [
                
            ]
        }
    }
    ;


var boundingRect:Rectangle;
var vector1:MyVector;
var myCenterX:Double = myStage.width/2;
var myCenterY:Double = myStage.height/2;

//second ball
//var myCenterX2:Double = myStage.width/2;
//var myCenterY2:Double = myStage.height/2;

var myDirection:MyVector = MyVector{x:1.0 y:1.0};
var circle:MyBall = MyBall{centerX:bind myCenterX centerY:bind myCenterY fill:Color.PERU radius:5.0 opacity:0.9};
//var circle2:MyBall = MyBall{centerX:bind myCenterX2 centerY:bind myCenterY2 fill:Color.RED radius:5.0 opacity:0.9};

var centerXRect:Double = myStage.width/2;
var platFormImg0:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg.png" };
var platFormImg1:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg1.png"};
var platFormImg2:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg2.png"};
var platFormImg3:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg3.png"};
var platFormImg4:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg4.png"};
var platFormImg5:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImg5.png"};
var platFormImgHalf:Image = Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\platFormImgHalf.png"};

//Platform animation - currently disabled...
var platFormLine:Timeline = Timeline{repeatCount:Timeline.INDEFINITE autoReverse:true keyFrames: [
                                                 KeyFrame{time:0.0s action:function():Void{playerPlatformImgView.image = platFormImg0;}}
                                                 KeyFrame{time:0.2s action:function():Void{playerPlatformImgView.image = platFormImg1;}}
                                                 KeyFrame{time:0.4s action:function():Void{playerPlatformImgView.image = platFormImg2;}}
                                                 KeyFrame{time:0.6s action:function():Void{playerPlatformImgView.image = platFormImg3;}}
                                                 KeyFrame{time:0.8s action:function():Void{playerPlatformImgView.image = platFormImg4;}}
                                                 KeyFrame{time:1.0s action:function():Void{playerPlatformImgView.image = platFormImg5;}}]};
//the player's Platform and platFormImage
var playerPlatformImgView:ImageView = ImageView{x:bind playerPlatform.x y:bind playerPlatform.y image:platFormImg0};
var playerPlatform:Rectangle = Rectangle{x:bind centerXRect y:myStage.height - 100.0 width:100.0 height:10.0 visible:false arcHeight:5.0 arcWidth:5.0};

var initialized:Boolean = false;

//The main gameloop
var gameLoop:Timeline = Timeline
                                {
                                    repeatCount: Timeline.INDEFINITE
                                    autoReverse:false
                                    keyFrames:
                                    [
                                                KeyFrame
                                                {
                                                    time: 0.01s
                                                    action:function():Void{moveBall(); if(playerWins()){println("WON!");unsetTxtFieldTimeline.stop();locked = true;gameLoop.stop();/*setTextField();*/ won = true;unsetTxtFieldTimeline.play();};}
                                                }
                                    ]
                                }
                                ;
var locked:Boolean = false;
var unsetTxtFieldTimeline:Timeline = Timeline{keyFrames: [KeyFrame{time:2.1s action:function():Void{setTextField();locked = false;}}]};

var gameLoopLostLife:Timeline = Timeline
                                        {
                                            repeatCount:Timeline.INDEFINITE
                                            autoReverse:false
                                            keyFrames:
                                                        [
                                                            KeyFrame
                                                            {
                                                                time:0.01s
                                                                action:function():Void{moveBallLifeLost();}
                                                            }

                                                        ]
                                        };
//Tests for chain reactions (player hits more than 1 block in under 2s --> reset chain loop)

//determine whether you are in the chain or not
var inChain:Boolean = false;
var chainMultiplier:Double = 1.0;
var chainBlocks:Integer = 0;
var chainSUM:Integer = 0;
var chainString:String = "  {chainBlocks}";
var chainString2:String = "chain miss!";
//The points from every hit and destructed block in the chain
var chainPoints:Integer = 0;
//The actually hit block
var hitBlock:MyDestructibles;
//The chain loop that starts a possible chain
var timeLeft:Number = 2.0;
var timeLoop:Timeline = Timeline{keyFrames: [KeyFrame{time:0s   values:timeLeft=>2.0 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.1s values:timeLeft=>1.9 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.2s values:timeLeft=>1.8 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.3s values:timeLeft=>1.7 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.4s values:timeLeft=>1.6 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.5s values:timeLeft=>1.5 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.6s values:timeLeft=>1.4 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.7s values:timeLeft=>1.3 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.8s values:timeLeft=>1.2 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:0.9s values:timeLeft=>1.1 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.0s values:timeLeft=>1.0 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.1s values:timeLeft=>0.9 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.2s values:timeLeft=>0.8 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.3s values:timeLeft=>0.7 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.4s values:timeLeft=>0.6 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.5s values:timeLeft=>0.5 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.6s values:timeLeft=>0.4 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.7s values:timeLeft=>0.3 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.8s values:timeLeft=>0.2 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:1.9s values:timeLeft=>0.1 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}
                                             KeyFrame{time:2.0s values:timeLeft=>0.0 action:function():Void{chainString = "Chain x{chainBlocks}   {timeLeft}s";}}]};
var chainLoop:Timeline = Timeline
                                {
                                    autoReverse:false
                                    keyFrames: 
                                    [   KeyFrame{time:0s action:function():Void{inChain = true;
                                                                                timeLoop.stop();
                                                                                timeLoop.play();
                                                                                chainTxtVisible = true;
                                                                                
                                                                                //chainBlocks += 1;
                                                                                //chainString = "CHAIN x{chainBlocks}   {timeLeft}s";
                                                                                chainPoints += hitBlock.myPointsToGive;
                                                                                if(chainBlocks>1){
                                                                                                  chainMultiplier+=0.5;
                                                                                                  chainString2 = "{chainPoints} x {chainMultiplier}";
                                                                                                  chainTxtVisible2 = true;
                                                                                                 }
                                                                               }
                                                },

                                        KeyFrame{time:2s values:timeLeft=>1.9 tween Interpolator.EASEBOTH action:function():Void{inChain = false;
                                                                                //calculate the points the player has gained in the chain
                                                                                chainSUM = Math.round(chainPoints * chainMultiplier);
                                                                                if(chainSUM>=5000)
                                                                                {
                                                                                    chainLineGreat.stop();
                                                                                    chainLineGreat.play();
                                                                                }

                                                                                if(chainBlocks > 1)
                                                                                {
                                                                                    //println("CHAINED {chainBlocks} blocks!");
                                                                                    chainString2 = "{chainPoints} x {chainMultiplier} \n= {chainSUM}";
                                                                                    
                                                                                    //if game over-screen is not currently shown
                                                                                    if(not visibleTxt4)
                                                                                    {
                                                                                        //chainSounds.media = chainSuccessSound;
                                                                                        //chainSounds.currentTime = 0.0s;
                                                                                        //chainSounds.play();
                                                                                    }
                                                                                }
                                                                                else
                                                                                {
                                                                                    //println("ONLY 1 Block hit in given time, resetting chain...");
                                                                                    chainString2 = "chain miss!";
                                                                                    chainTxtVisible2 = true;
                                                                                }

                                                                                //give the points to the player
                                                                                player.myScore += chainSUM;
                                                                                scoreString = "Score:  {player.myScore}";

                                                                                //calculate the outcome of the player's chain:
                                                                                chainSUM = 0;
                                                                                chainBlocks = 0;
                                                                                chainPoints = 0;
                                                                                chainMultiplier = 1.0;
                                                                                }
                                                }
                                         KeyFrame{time:3s action:function():Void{chainTxtVisible = false; chainTxtVisible2 = false;chainTxtVisible3 = false;}}
                                    ]
                                };

var chainTxtVisible:Boolean = false;
var chainTxtVisible2:Boolean = false;

var chainTxt:Text = Text
                        {
                            
                            font:Font
                            {
                                //oblique:true
                                embolden:true
                                size:40
                            }
                            
                            //font:Font.font(null, FontWeight.BOLD, 30);
                            effect: Lighting
                                {
                                    light: DistantLight { azimuth: -100 elevation: 30 }
                                    surfaceScale:4.0
                                }

                            visible:bind chainTxtVisible
                            x:5
                            y:500
                            content:bind chainString
                            fill:Color.GREEN
                        };
var chainTxt2:Text = Text
                        {
                            font:Font
                            {
                                oblique:true
                                embolden:true
                                size:30
                                name:"Verdana"
                            }
                            visible:bind chainTxtVisible2
                            x:5
                            y:550
                            content:bind chainString2
                            fill:Color.TOMATO
                        };
var chainTxtVisible3:Boolean = false;
var chainTxt3:Text = Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:60
                                name:"Verdana"
                            }
                            effect: Lighting
                                {
                                    light: DistantLight { azimuth: -100 elevation: 30 }
                                    surfaceScale:4.0
                                }
                            visible:bind chainTxtVisible3
                            x:5
                            y:640
                            content:"GREAT!"
                            fill:Color.RED
                        };
var chainLineGreat:Timeline = Timeline{keyFrames: [KeyFrame{time:0.0s action:function():Void{chainTxtVisible3 = true;}}
                                                   KeyFrame{time:0.1s action:function():Void{chainTxtVisible3 = false;}}
                                                   KeyFrame{time:0.2s action:function():Void{chainTxtVisible3 = true;}}
                                                   KeyFrame{time:0.3s action:function():Void{chainTxtVisible3 = false;}}
                                                   KeyFrame{time:0.4s action:function():Void{chainTxtVisible3 = true;}}
                                                   KeyFrame{time:0.5s action:function():Void{chainTxtVisible3 = false;}}
                                                   KeyFrame{time:0.6s action:function():Void{chainTxtVisible3 = true;}}
                                                   KeyFrame{time:0.7s action:function():Void{chainTxtVisible3 = false;}}
                                                   KeyFrame{time:0.8s action:function():Void{chainTxtVisible3 = true;}}
                                                   KeyFrame{time:1.0s action:function():Void{chainTxtVisible3 = false;}}]};





//Pops up the score values
var keyFrames:KeyFrame[];
var keyFrameScore:KeyFrame;

var scoreShowTimeLine:Timeline;

var duration:Duration = 0.3s;


function scoreShower(block:MyDestructibles)
{
    //Show the score popup when a brick is destroyed
                    scoreShowTimeLine = Timeline
                                        {
                                            autoReverse:false
                                            keyFrames: [KeyFrame
                                                {
                                                    time:0.0s
                                                    action:function():Void{showScore(block);}
                                                },
                                                KeyFrame
                                                {
                                                    time:0.3s
                                                    action:function():Void{hideScore(block);}
                                                }]
                                        }

                    scoreShowTimeLine.play();
}


function moveBall()
{

    //random number for the powerups
    var randNum;

    //move the powerups
    for(power in myPowerUps)
    {
        if(not power.destructed)
        {
            def wallTL1:Timeline = Timeline{autoReverse:false keyFrames: [KeyFrame{time:6s action:function():Void{throughWalls = false;/*power.twallImg.visible = false;*/circle.effect = null;circle.fill = Color.PERU;inIterPower = false;}}]};
            power.y += 1;
            if(playerPlatform.contains(Point2D{x:power.myImgView.x y:power.myImgView.y + power.myImgView.image.height})
            or playerPlatform.contains(Point2D{x:power.myImgView.x y:power.myImgView.y})
            or playerPlatform.contains(Point2D{x:power.myImgView.x y:power.myImgView.y+power.myImgView.image.height/2})
            or playerPlatform.contains(Point2D{x:power.myImgView.x + power.myImgView.image.width y:power.myImgView.y+power.myImgView.image.height/2})
            or playerPlatform.contains(Point2D{x:power.myImgView.x + power.myImgView.image.width y:power.myImgView.y+power.myImgView.image.height})
            or playerPlatform.contains(Point2D{x:power.myImgView.x + power.myImgView.image.width y:power.myImgView.y}))
            {
                power.myImgView.visible = false;
                power.twallImg.visible = true;
                power.caught = true;
                power.playMedia();
                throughWalls = true;
                circle.effect = GaussianBlur{radius:10};
                circle.fill = Color.BLUEVIOLET;
                wallTL1.play();
            }
            else if(power.y + power.myImgView.image.height >= myStage.height)
            {
                power.myImgView.visible = false;
                power.caught = false;
                power.destructed = true;
                inIterPower = false;
            }
        }
    }

    for(powerD in myPowerDowns)
    {
        if(not powerD.destructed)
        {
            def wallTL2:Timeline = Timeline{autoReverse:false keyFrames: [KeyFrame{time:10s action:function():Void{playerPlatform.width = 100;playerPlatformImgView.image = platFormImg0;/*platFormLine.play()*/;if(powerD.myType.equals("Dizzy")){for(block in myDestructibleObjects){block.myImgView.effect = null;inIterPower = false;}}}}]};
            powerD.y += 1;
            if(playerPlatform.contains(Point2D{x:powerD.myImgView.x y:powerD.myImgView.y + powerD.myImgView.image.height})
            or playerPlatform.contains(Point2D{x:powerD.myImgView.x y:powerD.myImgView.y})
            or playerPlatform.contains(Point2D{x:powerD.myImgView.x y:powerD.myImgView.y+powerD.myImgView.image.height/2})
            or playerPlatform.contains(Point2D{x:powerD.myImgView.x + powerD.myImgView.image.width y:powerD.myImgView.y+powerD.myImgView.image.height/2})
            or playerPlatform.contains(Point2D{x:powerD.myImgView.x + powerD.myImgView.image.width y:powerD.myImgView.y+powerD.myImgView.image.height})
            or playerPlatform.contains(Point2D{x:powerD.myImgView.x + powerD.myImgView.image.width y:powerD.myImgView.y}))
            {
                powerD.myImgView.visible = false;
                //reduce the playerPlatform's size by a half
                if(powerD.myType.equals("SizeReduce"))
                {
                    playerPlatform.width = 50;
                    playerPlatformImgView.image = platFormImgHalf;
                    //platFormLine.stop();
                }
                else if(powerD.myType.equals("Dizzy"))
                {
                    for(block in myDestructibleObjects)
                    {
                        block.myImgView.effect = InvertMask{pad:2};
                    }
                }

                powerD.caught = true;
                powerD.playMedia();
                wallTL2.play();
            }
            else if(powerD.y + powerD.myImgView.image.height >= myStage.height)
            {
                powerD.myImgView.visible = false;
                powerD.caught = false;
                powerD.destructed = true;
                inIterPower = false;
            }
        }
    }



    myCenterX += myDirection.x;
    myCenterY += myDirection.y;

    //Test for x-coordinates offscreen
    if(myCenterX - circle.radius < 0)
    {
        myCenterX = circle.radius;
        myDirection.x *= -1;
    }
    else if(myCenterX + circle.radius > myStage.width)
    {
        myCenterX = myStage.width - circle.radius;
        myDirection.x *= -1;
    }

    //Test for y-coordinates offscreen
    if(myCenterY - circle.radius < boundingRect.y)
    {
        myCenterY = boundingRect.y + circle.radius;
        myDirection.y *= -1;
    }
    //Player loses a life...
    else if(myCenterY + circle.radius + 40.0 > myStage.height)
    {
        myCenterY = myStage.height - circle.radius - 40.0;
        myDirection.y *= -1;

        if(player.myLifes - 1 >= 0)
        {
            player.myLifes--;
            lifeString = "x {player.myLifes}";
            gameLoop.pause();
            gameLoopLostLife.play();
        }
        else
        {
            player.myLifes = 0;
            lifeString = "x 0";
            scoreString = "GAME OVER!";
            visibleTxt4 = true;
            txtField5.toFront();
            chainSounds.media = gameOverSound;
            chainSounds.currentTime = 0.0s;
            chainSounds.play();
            //stop the main gameLoop
            gameLoop.stop();
        }
    }

    if(myDirection.y > 0)
    {
        //Test for collision with player platform:
        if(myCenterY + circle.radius == playerPlatform.y and myCenterX > playerPlatform.x and myCenterX < playerPlatform.x+playerPlatform.width and not (myCenterY > playerPlatform.y + playerPlatform.height))
        {

            //middle of the platform:
            if(myCenterX >= playerPlatform.x + playerPlatform.width/2 - circle.radius and myCenterX <= playerPlatform.x + playerPlatform.width/2 + circle.radius)
            {
                myDirection.x = 0;
            }
            //Left side of the platform
            else if(myCenterX >= playerPlatform.x and myCenterX <= playerPlatform.x + playerPlatform.width/2 )
            {
                myDirection.x =  (myCenterX - (playerPlatform.x + playerPlatform.width/2)) / 10;
                //println("MYDIRECTION LEFT: {myDirection.x}");
            }
            else if(myCenterX >= playerPlatform.x + playerPlatform.width/2 and myCenterX <= playerPlatform.x + playerPlatform.width )
            {
                myDirection.x =  (myCenterX - (playerPlatform.x + playerPlatform.width/2)) / 10;
                //println("MYDIRECTION RIGHT: {myDirection.x}");
            }

            /*
            //let the ball fly into the mousemove direction
            if(movementSpeed.x > 0)
            {
                if(myDirection.x < 0)
                {
                    myDirection.x *=  -1.0;
                }

            }
            else if(movementSpeed.x < 0)
            {
                if(myDirection.x > 0)
                {
                    myDirection.x *= -1.0;
                }
            }
            */

            myDirection.y *= -1;
        }
        else if(myCenterY > playerPlatform.y and myCenterX + circle.radius >= playerPlatform.x and myCenterX + circle.radius < playerPlatform.x + playerPlatform.width)
        {
            myDirection.x *= -1;
            myCenterX = playerPlatform.x - circle.radius;
            //myDirection.y =  0;
        }
        else if(myCenterY > playerPlatform.y and myCenterX - circle.radius < playerPlatform.x + playerPlatform.width and myCenterX - circle.radius > playerPlatform.x)
        {
            myDirection.x *= -1;
            myCenterX = playerPlatform.x + playerPlatform.width + circle.radius;
            //myDirection.y = 0;
        }
    }

    //Test for collision with the destructible blocks
    if(myCenterY+circle.radius <= 600)
    {
    for(block in myDestructibleObjects)
    {
        if(not block.iAmDestructed and not block.locked)
        {

        //Test for y - coordinate hit with blocks: hit block downwards
        if(myCenterY - circle.radius == block.y + block.height)
        {
            //The ball has hit something - now analyze deeper:
            var hit:Boolean = false;

            if(myCenterX + circle.radius > block.x and myCenterX + circle.radius < block.x + block.width)
            {
                hit = true;
            }
            else if(myCenterX - circle.radius > block.x and myCenterX + circle.radius < block.x + block.width)
            {
                hit = true;
            }
            else if(myCenterX - circle.radius > block.x and myCenterX - circle.radius < block.x + block.width)
            {
                hit = true;
            }

            if(hit)
            {
                //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
                bubbleSound.currentTime = 0.0s;
                bubbleSound.play();
                if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
                {
                    block.myHitPoints--;
                    

                    //give the player points for every ballhit
                    player.myScore += 10;
                    scoreString = "Score:  {player.myScore}"
                }
                //Let the block disappear
                if(block.myHitPoints == 0)
                {
                    //slightly modified to improve performance because Math.random() stresses the cpu a lot
                    if(not inIterPower)
                    {
                        randNum = Math.floor(Math.random()*10);
                        //Give a powerup:

                        if((randNum == 2 or randNum == 10) and not throughWalls)
                        {
                            inIterPower = true;
                            powerUp = MyPowerup{myType:"ThroughWalls" x:block.x y:block.y thePlatform:playerPlatform theStage:myStage cirlceTW:circle};
                            insert powerUp into myPowerUps;
                        }
                        else if((randNum == 4 or randNum == 16) and not throughWalls)
                        {
                            inIterPower = true;
                            powerDown = MyPowerDown{myType:"SizeReduce" x:block.x y:block.y thePlatform:playerPlatform theStage:myStage};
                            insert powerDown into myPowerDowns;
                        }
                        else if((randNum == 6 or randNum == 13) and not throughWalls)
                        {
                            inIterPower = true;
                            powerDown = MyPowerDown{myType:"Dizzy" x:block.x y:block.y thePlatform:playerPlatform theStage:myStage theBlocks:myDestructibleObjects};
                            insert powerDown into myPowerDowns;
                        }
                    }
                    if(level!=1 and level!=0 and level!=2)
                    {
                        powerDown = MyPowerDown{myType:"Dizzy" x:block.x y:block.y thePlatform:playerPlatform theStage:myStage theBlocks:myDestructibleObjects};
                        insert powerDown into myPowerDowns;
                    }
                    //powerUp = MyPowerup{myType:"ThroughWalls" x:block.x y:block.y thePlatform:playerPlatform theStage:myStage cirlceTW:circle};
                    
                    //myStage.scene.content = [myStage.scene.content, powerUp];

                    //Test for chain points
                    chainBlocks += 1;
                    chainLoop.stop();
                    chainLoop.play();

                    hitBlock = block;
                    
                    block.iAmDestructed = true;
                    block.myImgView.visible = false;
                    //block.visible = false;

                    scoreShower(block);
                }
                
                if(not throughWalls or block.inDestructible)
                {
                    myCenterY = block.y + block.height + circle.radius;
                    myDirection.y *= -1;
                }
                break;
            }
        }
        //Hit block upwards
        else if(myCenterY + circle.radius == block.y)
        {
            //The ball has hit something - now analyze deeper:
            var hit:Boolean = false;

            if(myCenterX + circle.radius > block.x and myCenterX + circle.radius < block.x + block.width)
            {
                hit = true;
            }
            else if(myCenterX - circle.radius > block.x and myCenterX + circle.radius < block.x + block.width)
            {
                hit = true;
            }
            else if(myCenterX - circle.radius > block.x and myCenterX - circle.radius < block.x + block.width)
            {
                hit = true;
            }

            if(hit)
            {
                //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
                bubbleSound.currentTime = 0.0s;
                bubbleSound.play();
                if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
                {
                    block.myHitPoints--;

                    //give the player points for every ballhit
                    player.myScore += 10;
                    scoreString = "Score:  {player.myScore}"
                }
                //Let the block disappear
                if(block.myHitPoints == 0)
                {

                    //Test for chain points
                    chainBlocks += 1;
                    chainLoop.stop();
                    chainLoop.play();

                    hitBlock = block;
                    
                    block.iAmDestructed = true;
                    block.myImgView.visible = false;
                    //block.visible = false;


                    scoreShower(block);
                    

                }
                
                if(not throughWalls or block.inDestructible)
                {
                    myCenterY = block.y - circle.radius;
                    myDirection.y *= -1;
                }
                break;
            }
        }

        //Test for x-coordinate hit with blocks: Hit block from the right
        else if(myCenterX - circle.radius == block.x + block.width)
        {
            //The ball has hit something - now analyze deeper:
            var hit:Boolean = false;

            if(myCenterY - circle.radius < block.y + block.height and myCenterY - circle.radius > block.y)
            {
                hit = true;
            }
            else if(myCenterY - circle.radius > block.y and myCenterY + circle.radius < block.y + block.height)
            {
                hit = true;
            }
            else if(myCenterY + circle.radius > block.y and myCenterY + circle.radius < block.y + block.height)
            {
                hit = true;
            }

            if(hit)
            {
                //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
                bubbleSound.currentTime = 0.0s;
                bubbleSound.play();
                if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
                {
                    block.myHitPoints--;

                    //give the player points for every ballhit
                    player.myScore += 10;
                    scoreString = "Score:  {player.myScore}"
                }
                //Let the block disappear
                if(block.myHitPoints == 0)
                {

                    //Test for chain points
                    chainBlocks += 1;
                    chainLoop.stop();
                    chainLoop.play();

                    hitBlock = block;

                    block.iAmDestructed = true;
                    block.myImgView.visible = false;
                    //block.visible = false;


                    scoreShower(block);
                }
                
                if(not throughWalls or block.inDestructible)
                {
                    myCenterX = block.x + block.width + circle.radius;
                    myDirection.x *= -1;
                }
                break;
            }
        }
        else if(myCenterX + circle.radius >= block.x and myCenterX + circle.radius < block.x + block.width)
        {
            //The ball has hit something - now analyze deeper:
            var hit:Boolean = false;

            if(myCenterY - circle.radius < block.y + block.height and myCenterY - circle.radius > block.y)
            {
                hit = true;
            }
            else if(myCenterY - circle.radius > block.y and myCenterY + circle.radius < block.y + block.height)
            {
                hit = true;
            }
            else if(myCenterY + circle.radius > block.y and myCenterY + circle.radius < block.y + block.height)
            {
                hit = true;
            }

            if(hit)
            {
                //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
                bubbleSound.currentTime = 0.0s;
                bubbleSound.play();
                if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
                {
                    block.myHitPoints--;

                    //give the player points for every ballhit
                    player.myScore += 10;
                    scoreString = "Score:  {player.myScore}"
                }
                //Let the block disappear
                if(block.myHitPoints == 0)
                {

                    //Test for chain points
                    chainBlocks += 1;
                    chainLoop.stop();
                    chainLoop.play();

                    hitBlock = block;
                    
                    block.iAmDestructed = true;
                    block.myImgView.visible = false;
                    //block.visible = false;


                    scoreShower(block);
                }
                
                if(not throughWalls or block.inDestructible)
                {
                    myCenterX = block.x - circle.radius;
                    myDirection.x *= -1;
                }
                break;
            }
        }
        /*
        else if(Point2D{x:block.x+block.width y:block.y}.equals(Point2D{x:myCenterX-circle.radius y:myCenterY+circle.radius}))
        {
            //Special-case:upright
            myDirection.y *= -1;
            myDirection.x *= -1;
        }
        else if(Point2D{x:block.x+block.width y:block.y+block.height}.equals(Point2D{x:myCenterX-circle.radius y:myCenterY-circle.radius}))
        {
            //Special-case:downright
            myDirection.y *= -1;
            myDirection.x *= -1;
        }
        else if(Point2D{x:block.x y:block.y+block.height}.equals(Point2D{x:myCenterX+circle.radius y:myCenterY-circle.radius}))
        {
            //Special-case:downleft
            myDirection.y *= -1;
            myDirection.x *= -1;
        }
        else if(Point2D{x:block.x y:block.y}.equals(Point2D{x:myCenterX+circle.radius y:myCenterY+circle.radius}))
        {
            //Special-case:upleft
            myDirection.y *= -1;
            myDirection.x *= -1;
        }*/

        
        //Special cases: The ball hits a block diagonal
        else if(block.contains(Point2D{x:myCenterX - circle.radius y:myCenterY - circle.radius}))
        {
            //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
            //println("special case: hit from downright");
            if(not throughWalls or block.inDestructible)
            {
                myDirection.x *= -1;
                //myDirection.y *= -1;
            }

            bubbleSound.currentTime = 0.0s;
            bubbleSound.play();
            if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
            {
                block.myHitPoints--;

                //give the player points for every ballhit
                player.myScore += 10;
                scoreString = "Score:  {player.myScore}"
            }
            //Let the block disappear
            if(block.myHitPoints == 0)
            {

                //Test for chain points
                chainBlocks += 1;
                chainLoop.stop();
                chainLoop.play();

                hitBlock = block;
                    
                block.iAmDestructed = true;
                block.myImgView.visible = false;
                //block.visible = false;


                scoreShower(block);
                 break;
            }
        }
        else if(block.contains(Point2D{x:myCenterX - circle.radius y:myCenterY + circle.radius}))
        {
            //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
            //println("special case: hit from upright");
            if(not throughWalls or block.inDestructible)
            {
                myDirection.x *= -1;
                //myDirection.y *= -1;
            }

            bubbleSound.currentTime = 0.0s;
            bubbleSound.play();
            if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
            {
                block.myHitPoints--;

                //give the player points for every ballhit
                player.myScore += 10;
                scoreString = "Score:  {player.myScore}"
            }
            //Let the block disappear
            if(block.myHitPoints == 0)
            {

                //Test for chain points
                chainBlocks += 1;
                chainLoop.stop();
                chainLoop.play();

                hitBlock = block;


                block.iAmDestructed = true;
                block.myImgView.visible = false;
                //block.visible = false;


                scoreShower(block);
                break;
            }
        }
        else if(block.contains(Point2D{x:myCenterX + circle.radius y:myCenterY - circle.radius}))
        {
            //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
            //println("special case: hit from downleft");
            if(not throughWalls or block.inDestructible)
            {
                myDirection.x *= -1;
                //myDirection.y *= -1;
            }

            bubbleSound.currentTime = 0.0s;
            bubbleSound.play();
            if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
            {
                block.myHitPoints--;

                //give the player points for every ballhit
                player.myScore += 10;
                scoreString = "Score:  {player.myScore}"
            }
            //Let the block disappear
            if(block.myHitPoints == 0)
            {

                //Test for chain points
                chainBlocks += 1;
                chainLoop.stop();
                chainLoop.play();

                hitBlock = block;

                block.iAmDestructed = true;
                block.myImgView.visible = false;
                //block.visible = false;


                scoreShower(block);
                break;
            }
        }
        else if(block.contains(Point2D{x:myCenterX + circle.radius y:myCenterY + circle.radius}))
        {
            //if the block is a moving block, lock it after being hit for 0.5s
                if(block.inAnimation)
                {
                    //block.playLockLine();
                    //println("Playing lockline...");
                }
            //println("special case: hit from upleft");
            if(not throughWalls or block.inDestructible)
            {
                myDirection.x *= -1;
                //myDirection.y *= -1;
            }

            bubbleSound.currentTime = 0.0s;
            bubbleSound.play();
            if(block.myHitPoints - 1 >= 0 and not block.inDestructible)
            {
                block.myHitPoints--;

                //give the player points for every ballhit
                player.myScore += 10;
                scoreString = "Score:  {player.myScore}"
            }
            //Let the block disappear
            if(block.myHitPoints == 0)
            {

                //Test for chain points
                chainBlocks += 1;
                chainLoop.stop();
                chainLoop.play();

                
                hitBlock = block;
                

                block.iAmDestructed = true;
                block.myImgView.visible = false;
                //block.visible = false;


                scoreShower(block);
                break;
            }
        }
    }
   }
  }
}

function showScore(b:MyDestructibles)
{
    //b.myTxtField.visible = true;
    //b.myTxtField.toFront();
    b.myScoreView.visible = true;

    //b.myScoreView.toFront(); this call costs a lot of cpu power, whyever...
}

function hideScore(b:MyDestructibles)
{
    for(block in myDestructibleObjects)
    {
        b.myScoreView.visible = false;
    }

}



function moveBallLifeLost()
{
    if(gameLoop.paused)
        {
            myCenterX = playerPlatform.x + playerPlatform.width/2;
            myCenterY = playerPlatform.y - circle.radius;
        }
}

//Determines if the player has won the game (and that is the case when all blocks have disappeared)
function playerWins():Boolean
{
    var everythingDestructed:Boolean = false;

    for(block in myDestructibleObjects)
    {
        if(block.iAmDestructed or block.inDestructible)
        {
            everythingDestructed = true;
        }
        else
        {
            return false;
        }
    }
    return everythingDestructed;
}

function setTextField()
{
    

    for(powerUp in myPowerUps)
    {
        powerUp.myImgView.visible = false;
    }
    for(powerDown in myPowerDowns)
    {
        powerDown.myImgView.visible = false;
    }

     circle.visible = false;

     visibleTxt1 = true;
     visibleTxt2 = true;

     if(player.myScore > 10000)
     {
        txtField1.content = "      You Win! \nYour score: {player.myScore}";
        txtField4.content = "              Good score, you gain an extra level!";
        visibleTxt3 = true;
     }
     else
     {
         txtField1.content = "      You Win! \nYour score: {player.myScore}";
     }

     txtField2.content = "  Left-Click on your mouse to broadcast the next Episode.";

}

function unsetTextField()
{
    visibleTxt1 = false;
    visibleTxt2 = false;
    visibleTxt3 = false;
}




function movePlayer(mouse:MouseEvent)
{
    centerXRect = mouse.x;

    if(centerXRect + playerPlatform.width > myStage.width)
    {
        centerXRect = myStage.width - playerPlatform.width - 10.0;
    }
    else if(centerXRect < 0)
    {
        centerXRect = 0;
    }
}

function shootBall()
{
    if(gameLoop.paused)
    {
        //shoot the ball up...
        myDirection.y = -2.5;
        myDirection.x =  2.5;
        //...stop the animation for the ball to stick to the playerPlatform...
        gameLoopLostLife.stop();
        //...and play the initial ball movement animation again:
        gameLoop.play();
    }

}

/*
function returnMovementSpeed(mouse:MouseEvent):MyVector
{
    //println("OLDPOS: {oldPosPlayerX}   {oldPosPlayerY}    NEWPOS   {mouse.x}     {playerPlatform.y}");

    if(mouseMoved)
    {
        //Do NOTHING
    }
    else
    {
        //println("released");
        moveVec = MyVector.vectorFromPoints(new Point(oldPosPlayerX,oldPosPlayerY), new Point(mouse.x,oldPosPlayerY));
        //println("NEWVEC:  {moveVec.x}     {moveVec.y}");
        
        oldPosPlayerX = playerPlatform.x;
        oldPosPlayerY = playerPlatform.y;
    }

    return moveVec;
}
*/

//create ALL blocks initially - test method...not in use right now
function createAllBlocks()
{
    var iter:Integer = 0;
    var xPos:Integer = 70;
    var yPos:Integer = 130;
    var block:MyDestructibles;
    //Create the blocks that can be destroyed: currently 209 blocks
    for(i in [0..209])
    {
        if(iter <= 13 and i != 0)
        {
            xPos += 55;
        }
        else
        {
            iter = 0;
            xPos = 70;
            yPos += 20;
        }
        block = MyDestructibles{width:50.0 height:15.0 x:xPos y:yPos myColor:Color.WHITE myHitPoints:1 myPointsToGive:100};
        insert block into myDestructibleObjects;
        //create a text field for every block
        var txtField3:Text =

                        Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:20
                            }
                            fill:Color.YELLOW
                            visible:false
                            content:"+{block.myPointsToGive} Points"
                            x:block.x
                            y:block.y
                        };

            insert txtField3 into myTxtFields;
            block.myTxtField = txtField3;
        iter++;
    }
    
    myStage.scene.content = [myStage.scene.content,myDestructibleObjects, myTxtFields];

    //play all logical loops
    gameLoop.play();
    gameLoop.pause();
    gameLoopLostLife.play();
}


//The main function to control the game behaviour and look
function createBlocks(patternDONOTSHOW:Integer[], patternRED:Integer[], patternBLACK:Integer[], patternYELLOW:Integer[], patternVIOLET:Integer[], patternBezier:Integer, patternTimeline:Integer[]):Void
{
    //empty the old structures

    for(powerUp in myPowerUps)
    {
        powerUp.myImgView.visible = false;
    }
    for(powerDown in myPowerDowns)
    {
        powerDown.myImgView.visible = false;
    }



    myDestructibleObjects = [];
    myTxtFields = [];
    blockTimeLines = [];
    myPowerUps = [];
    myPowerDowns = [];
    //most important!!!: empty the scenegraph content
    myStage.scene.content = null;

    def rectOfDeath:Rectangle = Rectangle{x:0 y:670 width:900 height:5 fill:Color.RED opacity:0.5};
    def scoreRect:Rectangle   = Rectangle{x:0 y:0 width:myStage.width height:50 fill:Color.BLACK opacity:0.5};
    myStage.scene.content = [scoreRect, backGrImg, Rectangle{x:10 y:15 width:playerPlatform.width height:playerPlatform.height fill:Color.CHOCOLATE arcHeight:5.0 arcWidth:5.0},boundingRect, circle, playerPlatform, txtField1, txtField2, txtField4,rectOfDeath, chainTxt,chainTxt2,chainTxt3,txtField5,levelTXT,gameInfos1,gameInfos2,playerPlatformImgView,loadingTxtField];

    var block:MyDestructibles;

    var iter:Integer = 0;
    var xPos:Integer = 70;
    var yPos:Integer;
    if(level != 0)
    {
        yPos = 100;
    }
    else
    {
        yPos = 130;
    }


    var whiteBlock:Boolean;

    var allowed:Boolean;
    var specialColor1:Boolean;
    var specialColor2:Boolean;
    var specialColor3:Boolean;
    var specialColor4:Boolean;
    var movement:Boolean;

    //Create the blocks that can be destroyed: currently 209 blocks
    for(i in [0..209])
    {
        allowed = true;
        whiteBlock = false;
        specialColor1 = false;
        specialColor2 = false;
        specialColor3 = false;
        specialColor4 = false;
        movement = false;

        for(numer in patternDONOTSHOW)
        {
            if(i.equals(numer))
            {
                allowed = false;
                break;
                //println("I: {i}   NUMER: {numer}");
            }
        }

        for(numerTime in patternTimeline)
            {
                if(i.equals(numerTime))
                {
                    movement = true;
                    break;
                }
            }


        for(numerCol1 in patternRED)
        {
            if(i.equals(numerCol1))
            {
                specialColor1 = true;
                break;
            }

        }
        for(numerCol2 in patternBLACK)
        {
            if(i.equals(numerCol2))
            {
                specialColor2 = true;
                break;
            }
        }
        for(numerCol3 in patternYELLOW)
        {
            if(i.equals(numerCol3))
            {

                specialColor3 = true;
                break;
            }
        }
        for(numerCol4 in patternVIOLET)
        {
            if(i.equals(numerCol4))
            {
                specialColor4 = true;
                break;
            }
        }

        if(iter <= 13 and i != 0)
        {
            xPos += 55;
        }
        else
        {
            iter = 0;
            xPos = 70;
            if(level!=0 and level != 1 and level != 2)
            {
                yPos += 15;
            }
            else
            {
                yPos += 20;
            }
        }

        if(allowed)
        {
            if(not movement)
            {
                if(level!=0 and level!=1 and level != 2)
                {
                    block = MyDestructibles{width:50.0 height:10.0 x:xPos y:yPos myColor:Color.WHITE myHitPoints:1 myPointsToGive:100};
                }
                else
                {
                    block = MyDestructibles{width:50.0 height:15.0 x:xPos y:yPos myColor:Color.WHITE myHitPoints:1 myPointsToGive:100};
                }

            }

            else
            {
                    var xBlock:Integer = 10;
                    var yBlock:Integer = 90;
                    block = null;
                    block = MyDestructibles{width:50.0 height:50.0 x:bind xBlock y:bind yBlock myColor:Color.WHITE myHitPoints:1 myPointsToGive:500};

                        //move the bricks around
                        def timeLineBlock:Timeline = Timeline{repeatCount:Timeline.INDEFINITE autoReverse:false keyFrames:
                        [KeyFrame{time:0s  values:xBlock => 100 tween Interpolator.LINEAR}
                         KeyFrame{time:10s values:xBlock => 750 tween Interpolator.LINEAR}
                         KeyFrame{time:10s values:yBlock => 90 tween Interpolator.DISCRETE}
                         KeyFrame{time:20s values:yBlock => 500 tween Interpolator.LINEAR}
                         KeyFrame{time:20s values:xBlock => 750 tween Interpolator.DISCRETE}
                         KeyFrame{time:30s values:xBlock => 100 tween Interpolator.LINEAR}
                         KeyFrame{time:30s values:yBlock => 500 tween Interpolator.DISCRETE}
                         KeyFrame{time:40s values:yBlock => 90 tween Interpolator.LINEAR}
                         KeyFrame{time:40s values:xBlock => 100 tween Interpolator.DISCRETE}
                        ]};
                        insert timeLineBlock into blockTimeLines;
                    


                    if(level==0 or level==1)
                    {
                        block.inAnimation = true;
                        //also show an ImageView for the moving blocks:
                        if(level==0)
                        {
                            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\ghost.png"} x:bind xBlock y:bind yBlock visible:true}
                        }
                        else
                        {
                            block.myHitPoints = 3;
                            block.myPointsToGive = 170;
                            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\redBrickBig.png"} x:bind xBlock y:bind yBlock visible:true}
                        }

                        myStage.scene.content = [myStage.scene.content, block.myImgView];
                        block.visible = false;
                        var txtField3:Text;

                        if(level==0)
                        {
                            txtField3 = Text
                                    {
                                        font:Font
                                        {
                                            embolden:true
                                            size:21
                                        }
                                        fill:Color.ORANGE
                                        visible:false
                                        content:"+{block.myPointsToGive} Points"
                                        x:block.x
                                        y:block.y
                                    };
                         }
                         else if(level==1)
                         {
                             txtField3 = Text
                                {
                                    font:Font
                                    {
                                        embolden:true
                                        size:24
                                    }
                                    fill:Color.RED
                                    visible:false
                                    content:"+{block.myPointsToGive} Points"
                                    x:block.x
                                    y:block.y
                                };
                         }


                    //insert txtField3 into myTxtFields;
                    //block.myTxtField = txtField3;
                    block.myScoreView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\500points.png"} x:block.x y:block.y visible:false};
                    myStage.scene.content = [myStage.scene.content,block.myScoreView];
                    }
            }

            whiteBlock = true;
            insert block into myDestructibleObjects;
        }

        if(whiteBlock and not specialColor1 and not specialColor2 and not specialColor3 and not specialColor4 and not block.inAnimation)
        {
            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\whiteBrick.png"} x:block.x y:block.y};
            block.visible = false;
            myStage.scene.content = [myStage.scene.content, block.myImgView];
            var txtField3:Text = 
           
                        Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:20
                            }
                            fill:Color.WHITE
                            visible:false
                            content:"+{block.myPointsToGive} Points"
                            x:block.x
                            y:block.y
                        };

            //insert txtField3 into myTxtFields;
            //block.myTxtField = txtField3;
            block.myScoreView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\100points.png"} x:block.x y:block.y visible:false};
            myStage.scene.content = [myStage.scene.content,block.myScoreView];
        }

        if(specialColor1 and not block.inAnimation)
        {
            
            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\redBrick.png"} x:block.x y:block.y};
            block.visible = false;
            myStage.scene.content = [myStage.scene.content, block.myImgView];
            
            block.myHitPoints = 3;
            block.myPointsToGive = 170;

            
            var txtField3:Text =

                        Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:24
                            }
                            fill:Color.RED
                            visible:false
                            content:"+{block.myPointsToGive} Points"
                            x:block.x
                            y:block.y
                        };
            

            //insert txtField3 into myTxtFields;
            block.myScoreView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\170points.png"} x:block.x y:block.y visible:false};
            myStage.scene.content = [myStage.scene.content,block.myScoreView];
        }
        if(specialColor2 and not block.inAnimation)
        {
            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\blackBrick10.png"} x:block.x y:block.y};
            block.visible = false;
            myStage.scene.content = [myStage.scene.content, block.myImgView];
            //Black blocks are indestructible...and thus give no points...
            block.inDestructible = true;
            block.height = 10;
            block.width = 55;
        }
        if(specialColor3 and not block.inAnimation)
        {
            block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\violetBrick.png"} x:block.x y:block.y};
            block.visible = false;
            myStage.scene.content = [myStage.scene.content, block.myImgView];
            block.myHitPoints = 1;
            block.myPointsToGive = 1000;

            var txtField3:Text =

                        Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:30
                            }
                            visible:false
                            fill:Color.VIOLET
                            content:"+{block.myPointsToGive} Points"
                            x:block.x
                            y:block.y
                        };
            

            //insert txtField3 into myTxtFields;
            //block.myTxtField = txtField3;
            block.myScoreView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\1000points.png"} x:block.x y:block.y visible:false};
            myStage.scene.content = [myStage.scene.content,block.myScoreView];
        }
        if(specialColor4 and not block.inAnimation)
        {
            if(i != 150 and i != 8)
            {
                block.myImgView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\yellowBrick.png"} x:block.x y:block.y};
                block.visible = false;
            }

            myStage.scene.content = [myStage.scene.content, block.myImgView];
            //block.opacity = 0.8;
            block.myHitPoints = 1;
            block.myPointsToGive = 250;

            var txtField3:Text =

                        Text
                        {
                            font:Font
                            {
                                embolden:true
                                size:20
                            }
                            visible:false
                            fill:Color.YELLOW
                            content:"+{block.myPointsToGive} Points"
                            x:block.x
                            y:block.y
                        };
            //insert txtField3 into myTxtFields;
            //block.myTxtField = txtField3;
            block.myScoreView = ImageView{image:Image{url:"file:/{new File(".").getCanonicalPath()}\\Bilder\\250points.png"} x:block.x y:block.y visible:false};
            myStage.scene.content = [myStage.scene.content,block.myScoreView];
        }

        iter++;

    }

    myStage.scene.content = [myStage.scene.content,myDestructibleObjects];
    

    if(player.myScore > 1000)
    {
        player.myLifes += 1;
    }

    lifeString = "x {player.myLifes}";
    


    gameLoop.play();
    gameLoop.pause();
    gameLoopLostLife.play();

    visibleTxt1 = false;
    visibleTxt2 = false;
    visibleTxt3 = false;

    //advance to the next level
    level++;
    
    if(level == 3)
    {
        level = 0;
    }
}

function moveTheseBricksNow()
{
    //play all block animations
    var start:Duration = 0s;
    for(tL in blockTimeLines)
    {
    def newTl:Timeline = Timeline{keyFrames:
        [
        KeyFrame{time:start action:function():Void{tL.play();}}
        ]};
        newTl.play();
        start+=2.0s;
    }

    def newTl2:Timeline = Timeline{keyFrames:
    [
        KeyFrame{time:start action:function():Void{blockTimeLines[sizeof blockTimeLines-1].play();}}
    ]};
    newTl2.play();
    //force the score-txt-field position-updates manually since binding won't work properly in for-loops
    forceTxtUpdates = Timeline{repeatCount:Timeline.INDEFINITE keyFrames: [KeyFrame{time:0.1s action:function():Void{for(block in myDestructibleObjects){if(block.inAnimation){block.myScoreView.x = block.x; block.myScoreView.y = block.y;}}}}]};
    forceTxtUpdates.play();
}


function run()
{

    //Create the rectangle the ball moves in.
    boundingRect = Rectangle{x:0 y:50 width:myStage.width height:myStage.height onMouseClicked:function(e){shootBall();
                                                                                                   if(won and not locked)
                                                                                                   {
                                                                                                       arcadeSoundLoop.stop();
                                                                                                       easterSoundLoop.stop();
                                                                                                       robotSoundLoop.stop();
                                                                                                       unsetTextField();
                                                                                                       //hide all remaining black blocks
                                                                                                       for(block in myDestructibleObjects)
                                                                                                       {
                                                                                                           block.visible = false;
                                                                                                       }
                                                                                                       //end all running timelines that move the blocks around
                                                                                                       for(tL in blockTimeLines)
                                                                                                       {
                                                                                                           tL.stop();
                                                                                                       }
                                                                                                       forceTxtUpdates.stop();
                                                                                                       won = false;
                                                                                                       circle.visible = true;

                                                                                                       println("LEVEL: {level}");
                                                                                                       if(level == 0)
                                                                                                       {
                                                                                                           def doNotShowTheseBricks:Integer[] =
                                                                                                           [0,1,2,3,4,5,9,10,11,12,13,14,15,16,17,18,
                                                                                                           24,25,26,27,28,29,30,31,39,40,41,42,43,44,53,54,
                                                                                                           55,56,57,58,67,68,69,70,71,72,80,81,82,83,84,85,86,93,94,95,
                                                                                                           96,97,98,99,100,106,107,108,109,110,111,112,113,114,121,122,
                                                                                                           123,124,125,126,127,128,136,137,138,139,140,141,142,151,152,
                                                                                                           153,154,155,156,165,166,167,168,169,170,171,185,186,200,201];

                                                                                                           //def doNotShowTheseBricks:Integer[] = [0..208];

                                                                                                           def yellow:Integer[] =
                                                                                                           [6,7,8,18,19,22,23,32,33,36,37,38,45,
                                                                                                           46,47,50,51,52,59,60,61,62,63,64,
                                                                                                           65,66,73,74,75,76,77,78,79,87,88,89,90,91,92,
                                                                                                           104,105,101,102,103,119,120,115,116,117,118,
                                                                                                           134,135,129,130,131,132,133,148,149,143,144,
                                                                                                           145,146,147,148,150,
                                                                                                           164,156,157,158,159,160,161,162,163,
                                                                                                           177,178,172,173,174,175,176,190,191,187,188,
                                                                                                           189,203,204,202];

                                                                                                           def moveTheseBricks:Integer[] =
                                                                                                           [0,1,2,3,179,180,181,182,183,184,192,193,
                                                                                                           194,195,196,197,198,199,205,206,207,
                                                                                                           208,209];

                                                                                                           levelString = "Episode 1 - Pacman's not dead...\nagain :)";
                                                                                                           def showLevelTimeline:Timeline = Timeline{keyFrames: [KeyFrame{time:3s action:function():Void{
                                                                                                           createBlocks(doNotShowTheseBricks, null, null, null,yellow,-1, moveTheseBricks);
                                                                                                           
                                                                                                           moveTheseBricksNow();
                                                                                                           visibleTxt5 = false;
                                                                                                           loadVisible = false;
                                                                                                           loadTimeLine.stop();
                                                                                                           arcadeSound.play();
                                                                                                           circle.visible = true;
                                                                                                           playerPlatformImgView.visible = true;
                                                                                                           /*platFormLine.play();*/}}]}
                                                                                                           showLevelTimeline.play();

                                                                                                           visibleTxt5 = true;
                                                                                                           loadVisible = true;
                                                                                                           circle.visible = false;
                                                                                                           playerPlatformImgView.visible = false;
                                                                                                           loadTimeLine.play();
                                                                                                           backGrImg.image = Image{url: "file:/{new File(".").getCanonicalPath()}\\Bilder\\background2.png"};
                                                                                                       }

                                                                                                       else if(level == 1)
                                                                                                       {
                                                                                                           
                                                                                                           def dNoS:Integer[] = 
                                                                                                           [0,1,2,4,5,6,7,8,9,11,12,13,14,15,16,17,19,
                                                                                                           20,21,22,24,25,26,27,28,29,30,31,32,34,35,
                                                                                                           37,38,39,40,41,42,43,44,45,46,47,50,51,52,
                                                                                                           53,54,55,56,57,68,69,70,71,82,83,84,
                                                                                                           97,98,111,112,113,124,125,126,127,
                                                                                                           138,139,140,141,152,153,154,155,166,167,
                                                                                                           168,169,170,171,178,179,180
                                                                                                           ];
                                                                                                           //def dNoS:Integer[] = [0..208];
                                                                                                        
                                                                                                           def red:Integer[] =
                                                                                                           [144,149,159,160,161,162,181,182,183,184,
                                                                                                           185,186,191,192,193,194,195,196,197,198,199,
                                                                                                           200,201,204,205,206,207,208,209];
                                                                                                           def black:Integer[] = [58,67,72,81,86,95,100,109,114,123,128,137,142,151];
                                                                                                           def violet:Integer[] = [3,10,73,74,75,78,79,80,87,89,92,94,101,102,103,106,107,108];
                                                                                                           def yellow:Integer[] = [18,23,33,36,48,49,85,88,93,96,99,110];
                                                                                                           def moveTheseBricks:Integer[] = [181,182,183,184,
                                                                                                           185,186,191,192,193,194,195,196,197,198,199,
                                                                                                           200,201,204,205,206,207,208,209];
                                                                                                           
                                                                                                           levelString = "Episode 2 - \nDestruction of heavy robots";
                                                                                                           def showLevelTimeline:Timeline = Timeline{keyFrames: [KeyFrame{time:3s action:function():Void{
                                                                                                           createBlocks(dNoS, red, black, violet, yellow, 206,moveTheseBricks);
                                                                                                           moveTheseBricksNow();
                                                                                                           robotSound.currentTime = 0.0s;
                                                                                                           robotSound.play();
                                                                                                           visibleTxt5 = false;
                                                                                                           loadVisible = false;
                                                                                                           circle.visible = true;
                                                                                                           playerPlatformImgView.visible = true;
                                                                                                           loadTimeLine.stop();
                                                                                                           /*platFormLine.play();*/}}]}
                                                                                                           showLevelTimeline.play();

                                                                                                           visibleTxt5 = true;
                                                                                                           loadVisible = true;
                                                                                                           circle.visible = false;
                                                                                                           playerPlatformImgView.visible = false;
                                                                                                           loadTimeLine.play();
                                                                                                           backGrImg.image = Image{url: "file:/{new File(".").getCanonicalPath()}\\Bilder\\background2.png"};
                                                                                                       }
                                                                                                       else if(level == 2)
                                                                                                       {
                                                                                                           blockTimeLines = null;
                                                                                                           def dadon:Integer[] =
                                                                                                           [15,16,17,18,19,20,21,22,23,24 ,
                                                                                                           25,26,29,30,31,32,37,38,39,
                                                                                                           40,43,44,45,52,53,
                                                                                                           54,57,58,67,68,
                                                                                                           71,82,85,96,99,110,113,124,127,138,
                                                                                                           141,142,151,152,155,156,157,164,
                                                                                                           165,166,169,170,171,172,177,178,
                                                                                                           179,180,183,184,185,186,187,188,
                                                                                                           189,190,191,192,193,194,202,203];

                                                                                                           //def dNoS:Integer[] = [0..208];

                                                                                                           def red:Integer[] =
                                                                                                           [2,3,4,6,7,9,10,11,33,34,35,36,46,51,59,66,72,
                                                                                                           81,86,95,100,109,114,123,128,137,143,150,
                                                                                                           158,163,173,174,175,176];
                                                                                                           def black:Integer[] =
                                                                                                           [1,5,8,12,
                                                                                                           90,91,104,105,118,119,
                                                                                                           196,197,198,199,200,
                                                                                                           201,204,205,206,207,208,209];
                                                                                                           def yellow:Integer[] = [47,48,49,50,60,65,73,76,
                                                                                                           77,80,87,89,92,94,101,103,106,108,115,117,120,122,
                                                                                                           129,132,133,136,144,149,159,160,161,162];
                                                                                                           
                                                                                                           levelString = "         Episode 3 - Easter Egg";
                                                                                                           def showLevelTimeline:Timeline = Timeline{keyFrames: [KeyFrame{time:3s action:function():Void{
                                                                                                           createBlocks(dadon, red, black, null, yellow, -1,null);
                                                                                                           visibleTxt5 = false;
                                                                                                           loadVisible = false;
                                                                                                           loadTimeLine.stop();
                                                                                                           easterSoundLoop.play();
                                                                                                           circle.visible = true;
                                                                                                           playerPlatformImgView.visible = true;
                                                                                                           /*platFormLine.play();*/}}]}
                                                                                                           showLevelTimeline.play();

                                                                                                           visibleTxt5 = true;
                                                                                                           loadVisible = true;
                                                                                                           circle.visible = false;
                                                                                                           playerPlatformImgView.visible = false;
                                                                                                           loadTimeLine.play();
                                                                                                           backGrImg.image = Image{url: "file:/{new File(".").getCanonicalPath()}\\Bilder\\background3.png"};
                                                                                                       }
                                                                                                   }
                                                                                               }
                                                                                               onMouseMoved:function(e){movePlayer(e);/*movementSpeed = returnMovementSpeed(e); mouseMoved = true;*/}
                                                                                               cursor:Cursor.NONE fill:Color.TRANSPARENT arcWidth:10.0 arcHeight:10.0};
    
    
    //initialized = true;
    def rectOfDeath:Rectangle = Rectangle{x:0 y:670 width:900 height:5 fill:Color.RED opacity:0.5};
    def scoreRect:Rectangle   = Rectangle{x:0 y:0 width:myStage.width height:50 fill:Color.BLACK opacity:0.5};
    myStage.scene.content = [scoreRect, backGrImg, Rectangle{x:10 y:15 width:playerPlatform.width height:playerPlatform.height fill:Color.CHOCOLATE arcHeight:5.0 arcWidth:5.0},boundingRect,circle, playerPlatform, txtField1, txtField2, txtField4,rectOfDeath, chainTxt,chainTxt2,chainTxt3,txtField5,levelTXT,playerPlatformImgView,loadingTxtField];

    //Determines the blocks that should not be shown - change this structure to create different patterns:
    def doNotShowTheseBricks:Integer[] =
    [0,1,2,3,4,5,9,10,11,12,13,14,15,16,17,18,
    24,25,26,27,28,29,30,31,39,40,41,42,43,44,53,54,
    55,56,57,58,67,68,69,70,71,72,80,81,82,83,84,85,86,93,94,95,
    96,97,98,99,100,106,107,108,109,110,111,112,113,114,121,122,
    123,124,125,126,127,128,136,137,138,139,140,141,142,151,152,
    153,154,155,156,165,166,167,168,169,170,171,185,186,200,201];

    //strange error:brick 150 should be in here, but when it is in this array, it is shown twice...
    def yellow:Integer[] =
    [6,7,8,18,19,22,23,32,33,36,37,38,45,
    46,47,50,51,52,59,60,61,62,63,64,
    65,66,73,74,75,76,77,78,79,87,88,89,90,91,92,
    104,105,101,102,103,119,120,115,116,117,118,
    134,135,129,130,131,132,133,148,149,143,144,
    145,146,147,148,150,
    164,156,157,158,159,160,161,162,163,
    177,178,172,173,174,175,176,190,191,187,188,
    189,203,204,202];

    //def yellow:Integer[] = [150];

    def moveTheseBricks:Integer[] =
    [0,1,2,3,179,180,181,182,183,184,192,193,
    194,195,196,197,198,199,205,206,207,
    208,209];

    //show the level after 3seconds
    
    def showLevelTimeline:Timeline = Timeline{keyFrames: [KeyFrame{time:3s action:function():Void{
        createBlocks(doNotShowTheseBricks, null, null, null,yellow,-1, moveTheseBricks);
        arcadeSound.play();
        moveTheseBricksNow();
        visibleTxt5 = false;
        loadVisible = false;
        loadTimeLine.stop();
        circle.visible = true;
        playerPlatformImgView.visible = true;
        /*platFormLine.play();*/}}]}
    showLevelTimeline.play();
    //level = 2;
    //won = true;
    visibleTxt5 = true;
    loadVisible = true;
    circle.visible = false;
    playerPlatformImgView.visible = false;
    loadTimeLine.play();

    //createBlocks(doNotShowTheseBricks, null, null, null,yellow,-1, moveTheseBricks);
    //pacManSound.play();
    //moveTheseBricksNow();
    //won = true;
    //level = 2;
    //createAllBlocks();
}



