/*
 * MyAnimation.fx
 *
 * Created on 14.07.2009, 12:19:46
 * Created by Clemens Weidenhiller / Jeme
 * Please do not use this code without the permission of the author.
 * Breakout v 1.2 Beta
 */

package breakout;

import javafx.scene.image.ImageView;

import javafx.scene.image.Image;

import javafx.animation.Timeline;

import javafx.animation.KeyFrame;

/**
 * @author jeme
 * This class represents an animation-class to draw the animation underneath the player-platform
 */

var myTexturesLEFT:Image[];
var myTexturesRIGHT:Image[];
var myTexture:Image;
var myTextureView:ImageView;
var animationLine:Timeline;
//The image iterator, initially set to the first image
var iter:Integer = 0;

public class MyAnimation
{
    public var myTexturePathsLEFT:String[];
    public var myTexturePathsRIGHT:String[];
    public var positionX:Integer;
    public var positionY:Integer;
    public var left:Boolean;
    public var right:Boolean;

    init
    {
        //create the Textures as normal Images
        for(fileName in myTexturePathsLEFT)
        {
            myTexture = Image
                        {
                            url:fileName
                        }
            insert myTexture into myTexturesLEFT;
        }

        println("Added {sizeof myTexturesLEFT} textures to the left animation");

        //create the Textures as normal Images
        for(fileName in myTexturePathsRIGHT)
        {
            myTexture = Image
                        {
                            url:fileName
                        }
            insert myTexture into myTexturesRIGHT;
        }

        println("Added {sizeof myTexturesRIGHT} textures to the right animation");

        //create the ImageView which images are constantly chnged during the animation
        myTextureView = ImageView
                        {
                            x:bind positionX
                            y:positionY         //no binding required since the y-coordinate always remains the same
                        }


        //and fill the animationLine with them
        animationLine = Timeline
                        {
                            repeatCount:Timeline.INDEFINITE
                            autoReverse:false
                            keyFrames:
                            [
                                KeyFrame
                                {
                                    time:0.5s
                                    //constantly change the image to create the illusion of animation
                                    action:function():Void
                                    {
                                                           if(left)
                                                           {
                                                               myTextureView.image = myTexturesLEFT[iter];
                                                               if(iter+1 < sizeof myTexturesLEFT)
                                                               {
                                                                   iter++;
                                                               }
                                                               else
                                                               {
                                                                   //reset the animation
                                                                   iter = 0;
                                                               }
                                                            }
                                                            else if(right)
                                                            {
                                                               myTextureView.image = myTexturesRIGHT[iter];
                                                               if(iter+1 < sizeof myTexturesRIGHT)
                                                               {
                                                                   iter++;
                                                               }
                                                               else
                                                               {
                                                                   //reset the animation
                                                                   iter = 0;
                                                               }
                                                            }
                                    }
                                }
                            ]
                        }


    }

    public function startAnimation():Void
    {
        animationLine.play();
    }
    public function resetAnimation():Void
    {
        //reset the shown picture to it's initial state
        iter = 0;
    }


}
